#!/usr/bin/perl -w
#
# $Id: emailprint.pl,v 1.2 2001/08/16 15:12:05 davee Exp $

# Set this to one if you don't actually want to print immediately
# on paper.  Uses xdvi to preview then the user can print from xdvi.
$PREVIEW = 0;

$open_char  = '<';
$close_char = '>';
$homedir    = $ENV{HOME};
$ul         = '_';

# This is 1 for headers, 2 for body and 3 for sig
$current_section = 1;

open(OUTPUT, ">tmpprint.tex");

print OUTPUT "\\documentclass[12pt,a4paper]{article}\n";
print OUTPUT "\\pagestyle{plain}\n";
print OUTPUT "\\usepackage[francais]{babel}\n";
print OUTPUT "\\usepackage[T1]{fontenc}\n";
print OUTPUT "\\usepackage{charter}\n";
print OUTPUT "\\begin{document}\n";
print OUTPUT "\\thispagestyle{empty}\n";
print OUTPUT "\\noindent\n";
print OUTPUT "\\begin{tabular}{ll}\n";
print OUTPUT "\\hline";
while (<STDIN>) {
    $rec = $_;
    chop($rec);
    if ($current_section == 1) {
        $rec =~ s/$open_char/(\\emph{/g;
        $rec =~ s/$close_char/})/g;
        $rec =~ s/$ul/\\_/g;
        # Handle any header: One or more alphanumeric characters plus a '-'
	# at the beginning of the line followed by a ': '.
        if ($rec =~ /^[A-Za-z0-9-]+: /) {
            print OUTPUT "{\\bf $&} & $'\\\\\n";
        }
        # For multi-line headers
        elsif ($rec =~ /^.+$/) {
            print OUTPUT "& $rec\\\\\n";
        } 
        elsif ($rec =~ /^$/) {
            $current_section = 2;
            print OUTPUT "\\hline\n\\end{tabular}\n";
            print OUTPUT "\\begin{verbatim}\n";
        }
    }
    elsif ($current_section == 2) {
        print OUTPUT "$rec\n";
        if ($rec =~ /^-- $/) {
            print OUTPUT "\\end{verbatim}\n";
            $current_section = 3;
            print OUTPUT "\\emph{";
        }

    }
    else {
        print OUTPUT "$rec\\\\\n";
    }
}
if ($current_section == 3) {
    print OUTPUT "}";
}
else {
    print OUTPUT "\\end{verbatim}\n";
}
print OUTPUT "\\end{document}\n";
close(OUTPUT);
system("latex -interaction=batchmode tmpprint.tex");
if ($PREVIEW == 1) {
    system("dvips tmpprint.dvi -o");
    system("gv tmpprint.ps");
}
else {
    system("dvips tmpprint.dvi");
    system("lpr tmpprint.ps");
}
system("rm -f $homedir/tmpprint.*");
system("rm -f $homedir/texput.log");
